package Xchat::nocturne::NocClones;
use strict;
use warnings;

# needs debugging: sometimes it outputs /who results
# on a user join.

##############################################################################
#     NocClones    # All this tiny little script does is checking on every   #
#          v1.0    # user join for clones of the same user and reports them  #
#################### back. No further action is taken.                       #
####################                                                         #
#   Aris Agrippas  # For on-demand clone scanning and/or hostmask matching   #
#     Copyright    # you can use the user_match script by b0at or just       #
#       ©2007      # use the /who command.                                   #
##############################################################################
# Warning: This works well on Unreal IRC servers. In case you're using it on #
# other protocols, please update the raw bindings in lines 24 and 25 and the #
# who command in line 37.                                                    #
##############################################################################

my ($sname,$version) = ("nocclones", "1.0");
Xchat::register($sname, $version, "Clone protection for Unreal servers", "");
Xchat::print("\002\00304Noc\00310Clones\003\002 included");
Xchat::command("query -nofocus ::Clones");

Xchat::hook_print( 'Join', 'clonecheck');
my $raw_352 = Xchat::hook_server('352', 'whoreply');
my $raw_315 = Xchat::hook_server('315', 'nada');
# Xchat::unhook($raw_315);     # in case i wanted to unhook
# Xchat::unhook($raw_352);

my $clones_check_in_progress = 0;
my @cloneslist = ();
my ($nick, $chan, $host) = ('', '', '');

sub clonecheck{
    ($nick, $chan, $host) = ($_[0][0], $_[0][1], $_[0][2]);
    $clones_check_in_progress = 1;
    $host = makehost($host);
    Xchat::command('who *' . $host);
    return Xchat::EAT_NONE;
}

sub makehost{
    my $temphost = shift;
    return substr($temphost, index($temphost,'@') + 1);
}

sub whoreply{
    return Xchat::EAT_NONE if (! $clones_check_in_progress);
    push @cloneslist, $_[0][7];
    return Xchat::EAT_ALL;
}

sub nada {
    return Xchat::EAT_NONE if (! $clones_check_in_progress);
	
	my $strResult = "\00308\x{205E}\x{205E}";
	$strResult .= "\002\00307\x{205E}\x{205E}\002\003\t ";
    $strResult .= "Clones from\00304 *@" . $host . "\003: ";

    my $cnt = 0;
    foreach (@cloneslist){
        if ($_ eq $nick){
            $strResult .= "\00307\002" . $_ . "\002\003 (" . $chan . ")";
        } else {
            $strResult .= "\00304\002" . $_ . "\002\003";
        }
        $cnt++;
        $strResult .= ", " if ($cnt < @cloneslist);
    }

    $strResult .= ". Total\002\00304 " . @cloneslist . "\00304\003\002.";
    
    
    if (@cloneslist > 1){
		my $focused_channel = Xchat::get_info("channel");

		# Output the clones found:
		if (substr($focused_channel, 0, 1) =~ /#/){
			Xchat::print($strResult);
		}

		Xchat::print($strResult, "::Clones");
    }


    $clones_check_in_progress = 0; # reset it to 0
    @cloneslist = ();              # empty the list too
    return Xchat::EAT_ALL;
}

